
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: bookmarks
#
#  id                :integer          not null, primary key
#  user_id           :integer
#  bookmarkable_id   :integer
#  bookmarkable_type :string
#  created_at        :datetime         not null
#  updated_at        :datetime         not null
#

class Bookmark < ApplicationRecord
  # Example of Trackable:
  # *current_user* create bookmark *bookmarkable*
  include Trackable

  belongs_to :user, counter_cache: true
  belongs_to :bookmarkable, polymorphic: true

  validates_presence_of :user, :bookmarkable
  validates :user_id, uniqueness: { scope: [:bookmarkable_id, :bookmarkable_type] }

  def recipient
    bookmarkable
  end
end
