
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

module ActivitiesFilterService

  def activities_filtered
    if !self.try(:draft?)
      acts = self.activities.where(key: activities_filter)
      ret = acts.select { |a| a.trackable != nil || a.key =~ /.\.destroy/ }
      ret
    else
      []
    end
  end

  def activities_filter
    [ 'complaint.create',
      'collection.create', 'collection.update', 'collection.destroy',
      'collection_item.create', 'collection_item.update', 'collection_item.destroy',
      'learning_object.create', 'learning_object.update', 'learning_object.destroy',
      'review.create',
      'download.create',
      'like.create', 'like.destroy'
    ]
  end
end
