
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'dspace'

class DspaceService

  # ID's of collections
  TEST_COLLECTION = 4
  PORTALMEC_COLLECTION = 3
  PORTALMEC_BETA_COLLECTION = 6
  BD_INT_OBJETOS_COLLECTION = 2

  def self.create_client
    dspace_client = Dspace::Client.new(dspace_api: config['link'])
    dspace_client.login config['login'], config['password']
    dspace_client
  end

  def self.link
    config['link']
  end

  private

  def self.config
    config = {}
    
    if Rails.env.production?
      config['link'] = "https://#{ENV['PORTALMEC_DSPACE_HOST']}:#{ENV['PORTALMEC_DSPACE_PORT']}"
      config['login'] = ENV['PORTALMEC_DSPACE_LOGIN']
      config['password'] = ENV['PORTALMEC_DSPACE_PASSWORD']
    else
      yml_file = YAML.load_file(Rails.root.join('config').to_s.concat('/dspace.yml'))
      yml = yml_file.fetch(Rails.env)

      config['link'] = "https://#{yml['host']}:#{yml['port']}"

      if  Rails.env.test?
        config['login'] = ENV['DSPACE_LOGIN']
        config['password'] = ENV['DSPACE_PASS']
      else
        config['login'] = yml['login']
        config['password'] = yml['password']
      end
    end

    config
  end
end
