
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

##
# The Feedback service abstract two actions: report_bug, that delegates behavior for a BugReporter service; and send_feedback, that stores a user review of the system.
class FeedbackService

  def initialize(bugreporter_service)
    @bugreporter_service = bugreporter_service
  end

  def get_report_service
    @bugreporter_service
  end

  ##
  # delegates the behavior for a bug reporter service
  def report_bug(bug)
    @bugreporter_service.report bug
  end

  ##Feedback is an user review of the system
  # store the feedbacks in database and send notification
  def send_feedback(feedback)
    # save and send an email
    feedback.save!
    # send notification
  end

end
