
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class BitstreamMimeWorker
  include Sidekiq::Worker

  def perform(id)
    attachment = LearningObject::Attachment.find(id)
    client = DspaceService.create_client
    return false if attachment.nil? || client.nil?

    file = client.bitstreams.retrieve(id: attachment.id_dspace).open
    begin
      mime = MimeMagic.by_magic(file)
      attachment.update(format: mime.mediatype, mime_type: mime.type) unless mime.blank?
    ensure
      File.unlink(file.path)
    end
  end
end
