
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class CreateTopicRelationships < ActiveRecord::Migration[4.2]
  def change
    create_table :topic_relationships do |t|
      t.references :parent, index: true
      t.references :child, index: true

      t.timestamps null: false
    end
    add_foreign_key :topic_relationships, :topics, column: :parent_id, name: 'parent_topic_foreign_key', on_delete: :cascade
    add_foreign_key :topic_relationships, :topics, column: :child_id, name: 'child_topic_foreign_key', on_delete: :cascade
    add_index :topic_relationships, [:parent_id, :child_id], unique: true, name: 'parent_and_child'
  end
end
