
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class CreateLearningObjectAttachments < ActiveRecord::Migration[4.2]
  def change
    create_table :learning_object_attachments do |t|
      t.string :name
      t.string :link
      t.string :retrieve_link
      t.text :description
      t.string :format
      t.string :mime_type
      t.integer :size
      t.string :bundle_name
      t.belongs_to :learning_object, index: true

      t.timestamps null: false
    end
    add_foreign_key :learning_object_attachments, :learning_objects, on_delete: :cascade
  end
end
