
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'fileutils'

  namespace :attachment_maintaining_service do

    desc 'Removing attachments using random politic'
    task :remove_attachments, [:limit] => :environment do |t, args|
      args.with_defaults(limit: 10.gigabyte)
      attachments_dir = attachment_dir + "/*"

      while dir_size(attachment_dir) > args.limit.to_i do
        # TODO now the politic is random, verify if politics like LRU or NRU improve the efficiency
        FileUtils.rm_r Dir[attachments_dir].sample
      end
    end

    private

    def dir_size(dir)
      `du -sb #{dir} | cut -f 1`.to_i
    end

    def attachment_dir
      Rails.root.join('public','attachments').to_s
    end

  end
