
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'rainbow'
require 'logger'

namespace :import do

  desc "Create Subject relations based on its metadata"
  task :subjects, [:log] => [:environment] do |t, args|
  
  logger = Logger.new(STDOUT)
  subject_relations = []

    Subject.all.each do |subject|
      logger.info("Creating relations of #{subject.name}")

      if tag_exists?(subject.name)
        tag = Tag.find_by_name(subject.name)
      else
        tag = Tag.create(name: subject.name)
      end

      tag.taggings.each do |tagging|
        subject_relation = SubjectRelation.new(subject: subject, subjectable_id: tagging.taggable_id, subjectable_type: tagging.taggable_type)
        subject_relations << subject_relation
      end

    end

    SubjectRelation.import subject_relations  
  end

  private

  def tag_exists? (name)
    Tag.where(name: name).exists?
  end

end
