
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'acceptance_helpers'
require 'shared/contexts'


resource 'Downloads' do

  explanation "An user can download the content of a learning object or collection."

  let(:learning_objects) { LearningObject.all }

  get '/v1/:type/:id/download' do
    include_context "authenticate_user"

    parameter :type, "Represents the type of object [‘learning_objects’,'collections']", scope: :download
    parameter :id, "The id of object", scope: :download

    let(:type) { 'learning_objects' }
    let(:id) {  @learning_object.id }

    before do
      @learning_object = create(:learning_object, publisher: @user)
      create(:attachment, learning_object: @learning_object )
    end

      example_request 'Download an object' do
      expect(status).to eq(302)
    end
  end

end
