
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'test_helper'

class V1::LearningObjectsControllerTest < ActionController::TestCase
  tests V1::LearningObjectsController
  include Devise::Test::ControllerHelpers

  test 'should user tagging a learning object' do
    auth_request users(:jack)
    tag = tags(:tag_three).name

    post :tagging, params: { id: learning_objects(:user_lo).id, tags: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :created
  end

  test 'should user untagging a learning object' do
    auth_request users(:jack)
    tag = tags(:tag_three).name

    post :untagging, params: { id: learning_objects(:user_lo).id, tags: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :ok
  end

  test 'should institution tagging a learning object' do
    auth_request users(:jack)
    institution = institutions(:ufpr)
    institution.users << users(:jack)
    tag = tags(:tag_one).name

    post :tagging, params: { id: learning_objects(:institution_lo).id, tags: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :created
  end

  test 'should institution untagging a learning object' do
    auth_request users(:jack)
    institution = institutions(:ufpr)
    institution.users << users(:jack)
    tag = tags(:tag_one).name

    post :untagging, params: { id: learning_objects(:institution_lo).id, tags: { name: tag, owner_id: users(:jack).id, owner_type: 'User' } }
    assert_response :ok
  end

end
