
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'test_helper'

class V1::MimeTypesControllerTest < ActionController::TestCase
  tests V1::MimeTypesController
  include Devise::Test::ControllerHelpers

  test 'should put update to mime_type with admin user and return :ok code' do
    auth_request users(:admin)
    mime_type = mime_types(:mp4)
    put :update, params: { mime_type: {
                                extension: '.mp45',
                                mime_type: 'video/mp45'
    }, id: mime_type.id }
    assert_response :ok
  end

  test 'should not put update to mime_type if user is not logged in and then return :unauthorized code' do
    mime_type = mime_types(:mp4)
    put :update, params: { mime_type: {
                                extension: '.mp45',
                                mime_type: 'video/mp45'
    }, id: mime_type.id }
    assert_response :unauthorized
  end

end
