
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'test_helper'

class FeedbackServiceTest < ActiveSupport::TestCase
  PORTALMEC_PROJECT_ID = 633
  mock = MiniTest::Mock.new
  report_service = GitlabBugreporterService.new(mock)
  feedback = FeedbackService.new(report_service)

  test 'initializing bug reporter service' do
    assert_equal feedback.get_report_service, report_service
  end

  test 'reporting bug' do
    bug = Bug.new
    bug.title = 'Título'
    bug.description = 'Descrição do bug'

    mock.expect(:create_issue,  nil, [PORTALMEC_PROJECT_ID, bug.title, description: bug.description])
    assert feedback.report_bug(bug)
  end
end
